<template>
  <div class="p-2">
    <!--    <transition :enter-active-class="proxy?.animate.searchAnimate.enter" :leave-active-class="proxy?.animate.searchAnimate.leave">
          <div v-show="showSearch" class="mb-[10px]">
            <el-card shadow="hover">
              <el-form ref="queryFormRef" :model="queryParams" :inline="true">
                <el-form-item label="" prop="playerId">
                  <el-input v-model="queryParams.playerId" placeholder="请输入" clearable @keyup.enter="handleQuery" />
                </el-form-item>
                <el-form-item label="" prop="itemId">
                  <el-input v-model="queryParams.itemId" placeholder="请输入" clearable @keyup.enter="handleQuery" />
                </el-form-item>
                <el-form-item label="道具数量" prop="quantity">
                  <el-input v-model="queryParams.quantity" placeholder="请输入道具数量" clearable @keyup.enter="handleQuery" />
                </el-form-item>
                <el-form-item>
                  <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
                  <el-button icon="Refresh" @click="resetQuery">重置</el-button>
                </el-form-item>
              </el-form>
            </el-card>
          </div>
        </transition>-->

    <el-card shadow="never">
      <template #header>
        <el-row :gutter="10" class="mb8">
          <!--          <el-col :span="1.5">
                      <el-button type="primary" plain icon="Plus" @click="handleAdd" v-hasPermi="['system:items:add']">新增</el-button>
                    </el-col>
                    <el-col :span="1.5">
                      <el-button type="success" plain icon="Edit" :disabled="single" @click="handleUpdate()" v-hasPermi="['system:items:edit']">修改</el-button>
                    </el-col>
                    <el-col :span="1.5">
                      <el-button type="danger" plain icon="Delete" :disabled="multiple" @click="handleDelete()" v-hasPermi="['system:items:remove']"
                        >删除</el-button
                      >
                    </el-col>
                    <el-col :span="1.5">
                      <el-button type="warning" plain icon="Download" @click="handleExport" v-hasPermi="['system:items:export']">导出</el-button>
                    </el-col>-->
          <right-toolbar v-model:showSearch="showSearch" @queryTable="getList"></right-toolbar>
        </el-row>
      </template>

      <el-table v-loading="loading" border :data="itemsList">
        <el-table-column label="" align="center" prop="id" v-if="false" />
        <el-table-column label="用户ID" align="center" prop="playerId" />
        <el-table-column label="道具名称" align="center" prop="itemName" />
        <el-table-column label="道具数量" align="center" prop="quantity" />
        <!--        <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
                  <template #default="scope">
                    <el-tooltip content="修改" placement="top">
                      <el-button link type="primary" icon="Edit" @click="handleUpdate(scope.row)" v-hasPermi="['system:items:edit']"></el-button>
                    </el-tooltip>
                    <el-tooltip content="删除" placement="top">
                      <el-button link type="primary" icon="Delete" @click="handleDelete(scope.row)" v-hasPermi="['system:items:remove']"></el-button>
                    </el-tooltip>
                  </template>
                </el-table-column>-->
      </el-table>

      <pagination v-show="total > 0" :total="total" v-model:page="queryParams.pageNum" v-model:limit="queryParams.pageSize" @pagination="getList" />
    </el-card>
    <!-- 添加或修改【请填写功能名称】对话框 -->
    <el-dialog :title="dialog.title" v-model="dialog.visible" width="500px" append-to-body>
      <el-form ref="itemsFormRef" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="" prop="playerId">
          <el-input v-model="form.playerId" placeholder="请输入" />
        </el-form-item>
        <el-form-item label="" prop="itemId">
          <el-input v-model="form.itemId" placeholder="请输入" />
        </el-form-item>
        <el-form-item label="道具数量" prop="quantity">
          <el-input v-model="form.quantity" placeholder="请输入道具数量" />
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button :loading="buttonLoading" type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="Items" lang="ts">
import { listItems, getItems, delItems, addItems, updateItems } from '@/api/system/business/playerItems';
import { ItemsVO, ItemsQuery, ItemsForm } from '@/api/system/business/playerItems/types';

const { proxy } = getCurrentInstance() as ComponentInternalInstance;

const itemsList = ref<ItemsVO[]>([]);
const buttonLoading = ref(false);
const loading = ref(true);
const showSearch = ref(true);
const ids = ref<Array<string | number>>([]);
const single = ref(true);
const multiple = ref(true);
const total = ref(0);

const queryFormRef = ref<ElFormInstance>();
const itemsFormRef = ref<ElFormInstance>();

const dialog = reactive<DialogOption>({
  visible: false,
  title: ''
});

const initFormData: ItemsForm = {
  id: undefined,
  playerId: undefined,
  itemId: undefined,
  quantity: undefined
};
const data = reactive<PageData<ItemsForm, ItemsQuery>>({
  form: { ...initFormData },
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    playerId: undefined,
    itemId: undefined,
    quantity: undefined,
    params: {}
  },
  rules: {
    id: [{ required: true, message: '不能为空', trigger: 'blur' }],
    playerId: [{ required: true, message: '不能为空', trigger: 'blur' }],
    itemId: [{ required: true, message: '不能为空', trigger: 'blur' }],
    quantity: [{ required: true, message: '道具数量不能为空', trigger: 'blur' }]
  }
});

const { queryParams, form, rules } = toRefs(data);

/** 查询【请填写功能名称】列表 */
const getList = async () => {
  loading.value = true;
  const res = await listItems(queryParams.value);
  itemsList.value = res.rows;
  total.value = res.total;
  loading.value = false;
};

/** 取消按钮 */
const cancel = () => {
  reset();
  dialog.visible = false;
};

/** 表单重置 */
const reset = () => {
  form.value = { ...initFormData };
  itemsFormRef.value?.resetFields();
};

/** 搜索按钮操作 */
const handleQuery = () => {
  queryParams.value.pageNum = 1;
  getList();
};

/** 重置按钮操作 */
const resetQuery = () => {
  queryFormRef.value?.resetFields();
  handleQuery();
};

/** 多选框选中数据 */
const handleSelectionChange = (selection: ItemsVO[]) => {
  ids.value = selection.map((item) => item.id);
  single.value = selection.length != 1;
  multiple.value = !selection.length;
};

/** 新增按钮操作 */
const handleAdd = () => {
  reset();
  dialog.visible = true;
  dialog.title = '添加【请填写功能名称】';
};

/** 修改按钮操作 */
const handleUpdate = async (row?: ItemsVO) => {
  reset();
  const _id = row?.id || ids.value[0];
  const res = await getItems(_id);
  Object.assign(form.value, res.data);
  dialog.visible = true;
  dialog.title = '修改【请填写功能名称】';
};

/** 提交按钮 */
const submitForm = () => {
  itemsFormRef.value?.validate(async (valid: boolean) => {
    if (valid) {
      buttonLoading.value = true;
      if (form.value.id) {
        await updateItems(form.value).finally(() => (buttonLoading.value = false));
      } else {
        await addItems(form.value).finally(() => (buttonLoading.value = false));
      }
      proxy?.$modal.msgSuccess('操作成功');
      dialog.visible = false;
      await getList();
    }
  });
};

/** 删除按钮操作 */
const handleDelete = async (row?: ItemsVO) => {
  const _ids = row?.id || ids.value;
  await proxy?.$modal.confirm('是否确认删除【请填写功能名称】编号为"' + _ids + '"的数据项？').finally(() => (loading.value = false));
  await delItems(_ids);
  proxy?.$modal.msgSuccess('删除成功');
  await getList();
};

/** 导出按钮操作 */
const handleExport = () => {
  proxy?.download(
    'business/playerItems/export',
    {
      ...queryParams.value
    },
    `playerItems${new Date().getTime()}.xlsx`
  );
};
// 监听路由参数变化

const route = useRoute(); // 获取 route 实例
onMounted(() => {
  // 检查路由参数中是否有 userId
  if (route.query.userId) {
    // 设置查询条件中的 userId
    queryParams.value.playerId = route.query.userId as string;
    // 自动执行查询
    getList();
  } else {
    getList();
  }
});
// 监听路由参数变化
watch(
  () => route.query,
  (newQuery, oldQuery) => {
    // 当查询参数发生变化时，重新加载数据
    if (newQuery.userId) {
      queryParams.value.playerId = newQuery.userId as string;
      // 重置分页
      queryParams.value.pageNum = 1;
      getList();
    }
  },
  { deep: true }
);
</script>
